

!!! Listing 1 : Web-Formular mit JavaScript-Aufruf

<form name="guestbook" onSubmit="return check_mailaddr()" 
   method="post"
   action="/cgi-bin/showform">

  Vorname:  <input type="text" size="25"
     name="vorname">
  <br>Nachname: <input type="text" size="25"
     name="nachname">
  <br>E-Mail:   <input type="text" size="25"
     name="email">
  <input type="submit" value="O.K.">

</form>

!!! Listing 2 : JavaScript-Funktion <I>check_mailaddr<I>

<script language="JavaScript">
  function check_mailaddr () {
    var is_it =true
    var Email = document.guestbook.email.value

    if (Email.indexOf("@") < 1) {
      alert("Hey Joe, das geht aber nicht s@...")
      is_it = false
    }
    return is_it
  }
</script>

!!! Listing 3 : PHP

<?php

  # Wenn der Submit-Knopf gedrckt war, Daten anzeigen...
  if ($submit) {
    show_data();
    # Wenn die Daten nicht "stimmen", Formular anzeigen und anhalten.
    if (!validate_form()) {
      show_form();
      die;
    }

    # Verbindung zur Datenbank herstellen, DB auswhlen
    $link = mysql_pconnect($host, $user, $pass);
    if (!$link)
      die("$user@$host kann die Datenbank nicht erreichen!");
    if (!mysql_select_db($db))
      die("$user@$host hat keinen Zugriff auf Datenbank $db!");

    # Daten holen und bereitstellen...
    $query = "select id, email from $table where ".
        "nachname = '$nachname' and vorname = '$vorname'";
    $res = mysql_query($query, $link);
    if (!$res)
      die("Query failed: $query ". mysql_error());

    $r = mysql_fetch_array($res, MYSQL_ASSOC);
    $oldmail = $r["email"];
    $id      = $r["id"];

    # Die drei Mglichkeiten
    # 1. Mailadresse existiert  nicht -> Datensatz einfgen
    # 2. Mailadresse existiert, aber anders -> Datensatz updaten
    # 3. Mailadresse existiert und ist gleich -> melden und halten.

    if (!$oldmail) {
      # Fall 1
      $query = "insert into $table (vorname, nachname, email) ".
             "values ('$vorname','$nachname','$email')";
      mysql_query($query, $link);
      print "Wir haben Sie ins Gstebuch aufgenommen.<br>";

    } elseif ($oldmail != $email) {
      # Fall 2
      $query = "update $table set email = '$email' where id = '$id'";
      mysql_query($query, $link);
      print "Wir haben Ihre E-Mail-Adresse gendert: " .
      "Vorher '$oldmail', jetzt '$email'.<br>";

    } else {
      # Fall 3
      print "Sie sind bereits im Gstebuch eingetragen.<br>";
    }
  } else {
    # Kein Submit gedrckt -> Formular anzeigen.
    show_form();
  }
?>

!!! Listing 4 : Perl

if (!$q->param()) {
  # Script ohne Parameter aufgerufen: Formular ausgeben.
  show_form($q);
} elsif (! $q->param("cancel")) {
  # Script mit Parametern aufgerufen: Parameter rausholen
  my ($oldmail,$id);
  my $vorname = $q->param("vorname");
  my $nachname = $q->param("nachname");
  my $email = $q->param("email");
  $q->dump();
  # Keine EMail-Adresse: Fehlermeldung. Dito fr fehlenden Nachnamen
  if (! $email)  {
    print "E-Mail-Adresse muss angegeben werden!\n";
    show_form($q);
    print $q->end_html;
    exit(0);
  }
  if (! $nachname)  {
    print "Nachname muss angegeben werden!\n";
    show_form($q);
    print $q->end_html;
    exit(0);
  }
  # Verbindung zur DB aufbauen (siehe Parameter am Anfang des Scripts)
  my $dbh = DBI->connect("DBI:$RDBMS:$DB",$user,$password) || 
    die "Konnte Datenbank $RDBMS\/$DB nicht ffnen";
  # Nachgucken, ob Eintrag fr Kombination in DB vorhanden
  my $query = "select id, email from $table where " .
    "nachname = '$nachname' and vorname = '$vorname'";
  my $sth = $dbh->prepare($query) || 
    die "Fehler in SQL-Statement '$query': " . $dbh->errstr;

  # Query ausfhren, 1. Ergebnis an $id und 2. an $oldmail binden
  $sth->execute() ||
    die "Fehler beim Ausfhren von '$query': " . $dbh->errstr;
  $sth->bind_col(1,\$id) ||
    die "Fehler bei \"bind\" fr '$query': " . $dbh->errstr;
  $sth->bind_col(2,\$oldmail) ||
    die "Fehler bei \"bind\" fr '$query': " . $dbh->errstr;

  # Ergebnis aus der DB holen.
  $sth->fetch();
  #
  # Drei Mglichkeiten: Eintrag erzeugen/ndern/nichts tun
  #
  if (!$oldmail) {
    # Neuer Eintrag
    $dbh->do("insert into $table (vorname, nachname, email) " .
             "values ('$vorname','$nachname','$email')");
    print "Wir haben Sie ins Gstebuch aufgenommen."
  } elsif ($oldmail ne $email)  {
    # Alten Eintrag ndern
    $dbh->do("update $table set email='$email' where id = $id");
    print "Wir haben Ihre E-Mail-Adresse gendert: " .
      "Vorher '$oldmail', jetzt '$email'."
  } else {
    # Nichts tun
    print "Sie sind bereits im Gstebuch eingetragen.";
  }
  $dbh->disconnect;
}

!!! Listing 5 : Tcl

# Ohne Parameter aufgerufen?
if {![array exists form]} {
    show_form
    exit 0
}

# Fehlerprfung
if {![info exists form(vorname)] || $form(vorname)==""} {
    puts "<b>Vorname mu angegeben werden!</b><p>"
    show_form
    exit 0
} elseif {![info exists form(nachname)] || $form(nachname)==""} {
    puts "<b>Nachname mu angegeben werden!</b><p>"
    show_form
    exit 0
} elseif {![info exists form(email)] || $form(email)==""} {
    puts "<b>Nachname mu angegeben werden!</b><p>"
    show_form
    exit 0
}

# Verbindung zur Datenbank aufbauen
if {[catch {pg_connect fp} conn]} {
    puts "<b>Konnte Datenbank nicht ffnen!</b></body></html>"
    exit 0
}

# Nachsehen, ob schon ein Eintrag fr Vorname, Nachname enthalten ist
set handle [pg_exec $conn "select id, email from gaestebuch\
                             where vorname='$form(vorname)'\
                               and nachname='$form(nachname)'"]
pg_result $handle -assign db
pg_result $handle -clear

# Die drei Mglichkeiten (siehe PHP-Listing)
if {![info exists db(0,email)]} {
    set handle [pg_exec $conn "select max(id) from gaestebuch"]
    set maxid  [pg_result $handle -getTuple 0]
    pg_result $handle -clear
    incr maxid
    set handle [pg_exec $conn \
     "insert into gaestebuch values\
        ($maxid,'$form(vorname)','$form(nachname)','$form(email)')"]
    puts "Wir haben Sie ins Gstebuch aufgenommen."
    pg_result $handle -clear
} elseif {[info exists db(0,email)] && $db(0,email) != $form(email)} {
    set handle [pg_exec $conn \
      "update gaestebuch set email='$form(email)' where id=$db(0,id)"]
    pg_result $handle -clear
    puts "Emailadresse gendert. Vorher '$db(0,email)', jetzt '$form(email)."
} else {
    puts "Sie sind bereits im Gstebuch eingetragen."
}
    
!!! Listing 6 : Python

#!/usr/bin/python

import gadfly
import cgi

# Hierhin gehoeren PrintHeader(), printFooter() und formString

def main():
    # Die Werte aus dem Form auslesen
    form = cgi.FieldStorage()
    if (not form.has_key("vorname") or form["vorname"].value == "") or \
       (not form.has_key("nachname") or form["nachname"].value == "") or \
       (not form.has_key("email") or form["email"].value == ""):

	# Nicht alles ins Formular eingetragen
        printHeader()                
        print "<H1>Bitte fuellen Sie alle Felder aus</h1>"
	# formString (fehlt hier) = leeres Formular
        print formString
        printFooter()        
        return
    else:
        # Daten im Formular -> in die Datenbank
        # Verbindung aufmachen
        connection = gadfly.gadfly("ixdata", "ixdatadir")
        cursor = connection.cursor()
	# Werte auslesen
	vorname = form["vorname"].value
	nachname = form["nachname"].value
	email = form["email"].value                
	# Jemanden mit diesem Vornamen/Nachnamen?
	cursor.execute("select id, vorname, nachname, email from "
		       "gaestebuch where vorname = ? and nachname = ?", 
		       (vorname, nachname))
	rows = cursor.fetchall()
	# Eintrag gefunden?
	if rows == []:
	    # Nichts gefunden -> neuen Eintrag in DB
	    # Maximalen Wert fuer ID ermitteln
	    cursor.execute("select max(id) from gaestebuch")
	    id = cursor.fetchone()[0]
	    # Neuen eintrag in DB
	    cursor.execute("insert into gaestebuch(id, vorname, nachname, "
			   "email) values (?, ?, ?, ?)", 
			   (id+1, vorname, nachname, email))
	    printHeader()
	    print "<h1>Sie sind nun in unserem Gaestebuch verewigt</h1>"
	    printFooter()
	else:
	    # Ein Eintrag wurde gefunden, Update der E-Mail-Adresse
	    id = rows[0][0]
	    cursor.execute("update gaestebuch set email = ? where id = ?", 
			  (email, id))
	    printHeader()
	    print "<h1>Ihre Email-Adresse wurde aktualisiert</h1>"
	    printFooter()
	# Abschliessend noch ein Datenbank-commit
	connection.commit()

main()

!!! Listing 7 : VBScript

<%
'---Lokales Speichern der Formularfelder aus Performancegrnden!
	Vorname = Request("Vorname") 
	Name = Request("Name")
	email = Request("eMail")

if vorname = "" and name = "" and email = "" then 
	'---Script ohne Parameter aufgerufen: Formular ausgeben.
	show_form
else
	'---Script mit Parametern aufgerufen
	fehler = ""	
	'--- Name und E-Mail fehlen -> Fehlermeldung generieren.
	if email = "" then fehler = fehler & "<li>Ungltige eMail-Adresse</li>"
	if Name = "" then fehler = fehler & "<li>Name bitte nicht leerlassen</li>"
	if fehler <> "" then
		Response.Write "<h3>Fehler:<hr><ul>" & Fehler & "</ul></h3>"
		show_form
		Response.Write "</BODY></HTML>"
		Response.End
	end if
	
	'--- ADO-Objekt instanziieren 
	Set objRS = Server.CreateObject("ADODB.RecordSet")
	' Verweis auf Datenbank
  	conn = "Provider=MSDASQL;Driver={Microsoft Access Driver 
               (*.mdb)};Dbq=f:\kom_data\gaeste.mdb;Uid=Admin;Pwd=;"
  	' SQL-Statement
  	sql = "SELECT * FROM Gaestebuch WHERE 
              Vorname = '" & Vorname & "' and Name ='" & Name & "'"
	'---Verbindung zur Datenbank aufbauen und Query ausfhren
	on error resume next
	objRS.open sql, Conn,1,3
	if err.number <> 0 then 
		Response.Write "<h3>Fehler beim ffnen der 
                     Datenbank: " & err.number & ":" & err.description
		Response.Write "</h3></BODY></HTML>"
		Response.End
	end if
	on error goto 0
	
	'---Die drei Mglichkeiten: siehe PHP-Listing
 	'---Neuer Eintrag
	if objRS.EOF Then
		objRS.AddNew 
		objRS("Name") = Name 
		objRS("eMail") = email
		objRS("Vorname") = Vorname 
		objRS.Update
		objRS.close
		Response.Write "Ihre Daten wurden gespeichert."
	Else
		'---Alten Eintrag ndern
		if not objRS.fields("email") = email then
		    objRS.fields("email") = email    
		    objRS.Update
		    Response.Write "Ihre eMail-Adresse wurde gendert."
		else
		    '---Nichts tun	
		    Response.Write "Sie sind bereits im Gstebuch eingetragen."
		End if
	End if
End if

'---Subroutine zum Ausgeben des FormulaobjRS.
sub show_form
%>
<form method="get" action="gaestebuch.asp">
'---Inhalt des Formulars (HTML)
</form>
<%
End sub
%>
